#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: generate_vserver_procs.pl, v1.1.0.3 Sun 23 Dec 2007 11:16:54 PM CET mstauber Exp $
# Copyright 2006 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.

# This handler polls a VPS for running processes and stores that info into CCE.

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

$DEBUG = 0;

my $cce = new CCE('Domain' => 'base-vserver');

if ($DEBUG == 0) {
    $cce->connectfd();
}
else {
    $cce->connectuds(); # only for debugging
}

if ($DEBUG == 0) {
    ($sys_oidmasternode) = $cce->find('VserverMasterNode');
    ($ok, $VserverMasterNode) = $cce->get($sys_oidmasternode);
    $vpsid = $VserverMasterNode->{gui_list_procid};
    $currentvpsid = $vpsid;

    ($sys_oidvpsstatus) = $cce->find('Vserver', {'vpsid' => $vpsid});
    ($ok, $vps) = $cce->get($sys_oidvpsstatus);
    $vpsstatus = $vps->{status};
}
else {
    $vpsid = "11"; 		# In debug mode only!
    $currentvpsid = "11"; 	# In debug mode only!
}

# Location of the vzlist-dump:
$vzpsdump = "/tmp/vserver-process-list.$vpsid";

# We are starting sane:
$bad_info_detected = '0';

# Parse existing VPS and shove their data into CCE:
&main;

# If we detect bad info, we will try again. Up to three times.
# Then we give up as something is barfed up badly.
if ($bad_info_detected < '3') {
    &main;
}
else {
    exit 1;
}

$cce->bye('SUCCESS');
exit(0);

##
# Subs:
##

sub main {

    # Generate dump:
    system("/usr/sbin/vzctl exec $vpsid /bin/ps auxwf > $vzpsdump");

    open (F, $vzpsdump) || die "Could not open $vzpsdump: $!";
    $VPSID[$a][0] = $vpsid;

    $PROCS = "";
    while ($line = <F>) {
        chomp($line);
        $PROCS = $PROCS . "#DELI#" . $line;
    }

    $VPSID[$a][2] = $PROCS;
    &feedthemonster;		# We found a new VPS. We need to feed the monster again!
    close(F);
    system("rm $vzpsdump");

}

# Subroutine that feeds the data into CCE:
sub feedthemonster {
	&validate;
	# This is where we actually populate CCE with the gathered info:
        @oids = $cce->find('Vserver', {'vpsid' => $currentvpsid});
        if ($#oids < 0) {
                #print "Object not yet in CCE. Creating new one.\n";
                ($ok) = $cce->create('Vserver', {
                'vpsid' => $VPSID[$a][0],
                'vps_processes' => $VPSID[$a][2],
                'timestamp' => time()
                });
		$new_vps_found = '1'; 			# We found a new VPS, one that we have never seen before and which
							# is not yet in CCE. We do not want to risk to populate CCE with ALL
							# the found new data in one go. So let us just set the most basic info
							# and the timestamp. 
							#
							# We also set $new_vps_found = '1' to run feedthemonster() again.
        }
        else {
	        #print "Object already present in CCE. Updating it.\n";
                # find the system object
		$new_vps_found = '0';
		&validate;
                ($sys_oid) = $cce->find('Vserver', {'vpsid' => $currentvpsid});
                ($ok, $sys) = $cce->get($sys_oid);
		
		# For debugging and logging purpose we do not write all 122 entries into CCE in one go. Instead we break it down
		# into multiple blocks so that we can troubleshoot /var/log/messages easily for data-blocks with values that CCE
		# did not like. 
		
                ($ok) = $cce->set($sys_oid, '',{ 	# beware: CLASS vs. Namespace (see schema)! Our NameSpace is empty, hence: ''
                'vpsid' => $VPSID[$a][0],
                'vps_processes' => $VPSID[$a][2],
                'timestamp' => time()
                });

	}

}


# Validate the settings before we pass them on to CCE:
sub validate {

}

$cce->bye('SUCCESS');
exit(0);

# Legend of Matrix columns:

# 0 = vpsid
# 2 = processes
